<template>
  <div>
    <v-container class="d-flex justify-center mb-10">
      <v-sheet max-width="1000px">
        <!-- Headline -->
        <v-row>
          <v-col cols="12">
            <v-card
              class="mx-auto"
              outlined
              color="#385F73"
            >
              <v-container class="d-flex justify-space-between px-5 white--text">
                <div>
                  <v-card-title class="headline">
                    Advanced search
                  </v-card-title>

                  <v-card-subtitle class="white--text text--darken-5">
                    2 billion items available here through a library
                  </v-card-subtitle>

                  <v-container>
                    <v-row v-if="!searchParams.q.length">
                      <v-col class="text-center display-1 mb-10 grey--text text--lighten-1">
                        Please enter some keyword
                      </v-col>
                    </v-row>

                    <v-row v-else>
                      <v-col
                        v-for="(param, i) in searchParams.q"
                        :key="i"
                        class="d-flex align-center mb-3"
                        cols="12"
                        sm="12"
                        md="12"
                      >
                        <v-btn
                          icon
                          color="red"
                          class="mr-2"
                          @click="handleRemoveSearchParams({ index: i })"
                        >
                          <v-icon>mdi-close</v-icon>
                        </v-btn>

                        <v-select
                          v-model="searchParams.filter_by[i]"
                          :items="items"
                          label="Search term"
                          hide-details
                          outlined
                          dark
                          class="mr-2"
                        />

                        <v-text-field
                          v-model="searchParams.q[i]"
                          label="Search theses here..."
                          placeholder="Search theses here..."
                          outlined
                          hide-details
                          dark
                          class="mr-2"
                          autocomplete="off"
                        />
                      </v-col>
                    </v-row>

                    <v-row>
                      <v-col
                        class="d-flex justify-end"
                        cols="12"
                      >
                        <v-btn
                          class="mr-2"
                          @click="handleAddSearchParam"
                        >
                          Add
                        </v-btn>
                        <v-btn
                          class="mr-2"
                          @click="handleClearSearchParam"
                        >
                          Clear
                        </v-btn>
                        <v-btn
                          @click="trigger"
                        >
                          Search
                        </v-btn>
                      </v-col>
                    </v-row>
                  </v-container>
                </div>

                <v-img
                  max-width="300"
                  class="ma-5"
                  contain
                  :src="require('@/assets/images/svg/search.svg')"
                />
              </v-container>
            </v-card>
          </v-col>
        </v-row>
      </v-sheet>
    </v-container>

    <v-footer app />
  </div>
</template>

<script>
import VFooter from '@/components/Footer'
export default {
  components: {
    VFooter
  },

  data () {
    return {
      items: ['Title', 'Author', 'Subject', 'Tag', 'Year'],
      searchParams: { filter_by: [''], q: [''] }
    }
  },

  methods: {
    handleAddSearchParam () {
      this.searchParams.filter_by.push('')
      this.searchParams.q.push('')
    },

    handleClearSearchParam () {
      this.searchParams = { filter_by: [''], q: [''] }
    },

    handleRemoveSearchParams ({ index }) {
      this.searchParams.filter_by.splice(index, 1)
      this.searchParams.q.splice(index, 1)
    },

    trigger () {
      this.$router.push({
        name: 'public-archives',
        query: this.searchParams
      })
    }
  }
}
</script>
